<?php
require_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/include/prolog_admin_before.php");

if ( ! CModule::IncludeModule('learning') )
	throw new Exception();

require_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/classes/general/tar_gz.php");

$arHhcPathes = array(
	'C:\Program Files\HTML Help Workshop\hhc.exe',
	'C:\Program Files (x86)\HTML Help Workshop\hhc.exe'
);

if (isset($_POST['hhcPathIndex']))
{
	$hhcPathIndex = min(count($arHhcPathes) - 1, (int) abs($_POST['hhcPathIndex']));

	CUserOptions::SetOption(
		'bitrix_internal', 
		'hhcPathIndex', 
		$hhcPathIndex
	);
}

$hhcPathIndex = (int) CUserOptions::GetOption('bitrix_internal', 'hhcPathIndex', 0);

$hhcPath = $arHhcPathes[$hhcPathIndex];

if ( ! isset($_POST['courses']) )
{
	$orderBy = null;		// don't sort by default
	$orderDirection = 'ASC';
	$arOrder = array();

	if (isset($_GET['ORDER_BY']))
	{
		if ($_GET['ORDER_BY'] === 'COURSE_ID')
			$orderBy = 'ID';
		else
			$orderBy = 'NAME';

		if ($_GET['ORDER_DIRECTION'] === 'ASC')
			$orderDirection = 'ASC';
		else
			$orderDirection = 'DESC';
	}

	if ($orderBy)
		$arOrder = array($orderBy => $orderDirection);

	?>
	<form action="" method="POST">
	   CHM :<br>
	<?php
	foreach ($arHhcPathes as $pathIndex => $path)
	{
		?>
		<label>
		<input type="radio" name="hhcPathIndex" 
			value="<?php echo $pathIndex; ?>"
			<?php
			if ($pathIndex == $hhcPathIndex)
				echo ' checked="checked" ';
			?>
			><?php echo $path; ?></label><br />
		<?php
	}
	?>
	<br>
	  : <a href="?ORDER_BY=COURSE_ID&amp;ORDER_DIRECTION=ASC"> </a> 
	/ <a href="?ORDER_BY=COURSE_ID&amp;ORDER_DIRECTION=DESC"> </a><br><br>

	  : <a href="?ORDER_BY=NAME&amp;ORDER_DIRECTION=ASC"> </a> 
	/ <a href="?ORDER_BY=NAME&amp;ORDER_DIRECTION=DESC"> </a><br><br>

<script language="javascript">
function toggle(source)
{
	console.log('toggle');
	checkboxes = document.getElementsByName('courses[]');
	for (var i =0; i < checkboxes.length; i++)
	{
		console.log(i);
		console.log(checkboxes[i]);
		checkboxes[i].checked = source.checked;
	}
}
</script>

		<label><input type="checkbox" checked="checked" onclick="toggle(this)" />  </label><br/>
		<br />
		<ul>
		<?php

		$rsCourses = CCourse::GetList($arOrder, array('ACTIVE' => 'Y'));
		while ($arCourse = $rsCourses->Fetch())
		{
			echo '<li><label><input type="checkbox" checked="checked" name="courses[]" value="' . (int) $arCourse['ID'] 
				. '">[' . (int) $arCourse['ID'] . '] ' . $arCourse['NAME'] . "</label></li>";
		}
		?>
		</ul>
		<?php
		echo bitrix_sessid_post();
		?>
		<br><input type="submit" name="submit" value="    CHM ">
	</form>
	<?php
}
elseif(check_bitrix_sessid())
{
	if (is_array($_POST['courses']))
	{
		try
		{
			$batFileContent = "@echo off \r\n"
				. 'set HHC="' . $hhcPath . '"' . "\r\n\r\n";

			$arFileList = array();
			$destFolder = "!newHelpCourses";

			natsort($_POST['courses']);

			$_SERVER["DOCUMENT_ROOT"];
			$destArchiveFolderPre = 'destination_folder';
			$destArchiveFolder    = $destArchiveFolderPre . '/chm_courses';
			$destArchiveName      = date('Y-m-d_H-i-s') 
				. '_COURSE_ID=' 
				. implode(
					',',
					array_map(
						function ($i) { return ((int) $i); },
						$_POST['courses']
					)
				) 
				. '.tar.gz';
			
			DeleteDirFilesEx($destArchiveFolder);
			DeleteDirFilesEx($destFolder);

			mkdir($_SERVER["DOCUMENT_ROOT"] . '/' . $destArchiveFolderPre);
			mkdir($_SERVER["DOCUMENT_ROOT"] . '/' . $destArchiveFolder);
			mkdir($_SERVER["DOCUMENT_ROOT"] . '/' . $destFolder);

			foreach ($_POST['courses'] as $courseId)
			{
				$courseId = (int) $courseId;

				if ($courseId <= 0)
					throw new Exception();

				$o = new CChmHelper(
					$destFolder . "/Course_" . $courseId, 
					$courseId
				);

				$batFileContent .= 'echo Process COURSE_ID = ' . $courseId . "...\r\n";
				$batFileContent .= '%HHC% .\Course_' . $courseId . "\\bsm.hhp > journal.log\r\n";
				$batFileContent .= 'copy /b .\Course_' . $courseId . "\\*.chm .\\\r\n";
				$batFileContent .= "\r\n\r\n";

				$o->processItems();

				$o->finalize();

				/*
				$fileName = '/' . $destArchiveFolderPre . '/' . date('dmY_Hi') . '_COURSE_ID=' . $courseId . '.tar.gz';
				mkdir($_SERVER["DOCUMENT_ROOT"] . '/' . $destArchiveFolderPre . '/');
				$o->packToArchive($_SERVER["DOCUMENT_ROOT"] . $fileName);
				*/

				$arFileList = array_merge($arFileList, $o->getFilesList());

				unset ($o);
			}

			$batFileName = $_SERVER["DOCUMENT_ROOT"] . '/' . $destFolder . '/run.bat';

			file_put_contents(
				$batFileName,
				$batFileContent
			);

			$arFileList[] = $batFileName;

			CChmHelper::makeArchive(
				$arFileList,
				$_SERVER["DOCUMENT_ROOT"] . '/' . $destFolder,
				$_SERVER["DOCUMENT_ROOT"] . '/' . $destArchiveFolder . '/' . $destArchiveName);

			header('Location: /' . $destArchiveFolder . '/' . $destArchiveName);
		}
		catch (Exception $e)
		{
			echo 'Got exception: ' . $e->getLine() . '; ' . $e->getFile();
		}
	}
}


class CChmHelper
{
	protected $courseId   = false;
	protected $courseName = '';
	protected $destFolder = false;
	protected $arFileList = array();
	protected $fpHhk      = false;
	protected $fpHhc      = false;

	protected $dataHhp = '[OPTIONS]
		Binary TOC=Yes
		Compatibility=1.1 or later
		Contents file=bsm.hhc
		Default Font=Tahoma, 8,204
		Default Window=bsm_wnd
		Default topic=index.htm
		Display compile progress=Yes
		Error log file=_errorlog.txt
		Full-text search=Yes
		Index file=bsm.hhk
		Language=0x419  ()
		';

	protected $dataHhk = '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
		<HTML>
		<HEAD>
		<meta name="GENERATOR" content="Microsoft&reg; HTML Help Workshop 4.1">
		<!-- Sitemap 1.0 -->
		</HEAD>
		<BODY>
		<OBJECT type="text/site properties">
			<param name="FrameName" value="right">
		</OBJECT>
		<UL>';

	protected $dataHhc = '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
		<HTML>
		<HEAD>
		<meta name="GENERATOR" content="Microsoft&reg; HTML Help Workshop 4.1">
		<!-- Sitemap 1.0 -->
		</HEAD>
		<BODY>
		   <OBJECT type="text/site properties">
		     <param name="Window Styles" value="0x800025">
		     <param name="FrameName" value="right">
		     <param name="Font" value="Tahoma,8,204">
		     <param name="comment" value="title:Online Help">
		     <param name="comment" value="base:index.htm">
		   </OBJECT>
		<UL>';

	protected $arDataFiles = array();
	protected $prevDepth = false;
	protected $arProcessedFiles = array();
	protected $arItems = false;
	protected $itemsTotal = false;


	public function __construct($destFolder, $courseId)
	{
		$this->courseId = $courseId;
		$this->linksPattern = '/COURSE_ID=' . $this->courseId . '&LESSON_ID=(\d)/';
		$this->linksPatternChapters = '/COURSE_ID=' . $this->courseId . '&CHAPTER_ID=(\d)/';
		$this->destFolder = $_SERVER["DOCUMENT_ROOT"] . '/' . $destFolder;

		DeleteDirFilesEx($destFolder);
		mkdir($this->destFolder);
		mkdir($this->destFolder . '/lessons/');
		mkdir($this->destFolder . '/embed/');
		mkdir($this->destFolder . '/images/');
		mkdir($this->destFolder . '/icons/');

		$arFilesToCopy = array(
			'docstyle.css', 'wow.js',
			'images/1.gif', 'images/bg.gif', 'images/minus.gif',
			'images/plus.gif', 'images/q_left_bottom.gif',
			'images/top_bg.gif', 'images/top_left.gif',
			'images/vdots_menu.gif', 'images/vdots_toolbar.gif',
			'icons/arr_left.gif',
			'icons/arr_right.gif',
			'icons/br.gif',
			'icons/chapter.gif',
			'icons/course.gif',
			'icons/gradebook.gif',
			'icons/imp.gif',
			'icons/left.gif',
			'icons/left_hide.gif',
			'icons/left.jpg',
			'icons/lesson.gif',
			'icons/line.gif',
			'icons/materials.gif',
			'icons/prim.gif',
			'icons/printer_b_b.gif',
			'icons/printer_b.gif',
			'icons/printer_s.gif',
			'icons/right.gif',
			'icons/right_hide.gif',
			'icons/right.jpg',
			'icons/signminus.gif',
			'icons/signplus.gif',
			'icons/test.gif',
			'icons/tests.gif',
			'icons/warning.gif'
		);

		$this->fpHhp = fopen($this->destFolder . '/bsm.hhp', 'wb');
		$this->fpHhk = fopen($this->destFolder . '/bsm.hhk', 'wb');
		$this->fpHhc = fopen($this->destFolder . '/bsm.hhc', 'wb');

		$this->arFileList[] = $this->destFolder . '/bsm.hhp';
		$this->arFileList[] = $this->destFolder . '/bsm.hhk';
		$this->arFileList[] = $this->destFolder . '/bsm.hhc';

		if ( ! (
			is_resource($this->fpHhk)
			&& is_resource($this->fpHhc)
			&& is_resource($this->fpHhp)
		))
		{
			throw new Exception();
		}

		$rsCourse = CCourse::GetByID($courseId);

		if ( ! ($arCourse = $rsCourse->Fetch()) )
			throw new Exception();

		$this->courseName = $arCourse['NAME'];

		$this->dataHhp .= 'Title=' 
			. str_replace('"', "'", $arCourse['NAME']) . "\r\n"
			. 'Compiled file=' . preg_replace('/[^A-Za-z--0-9_\-]/', '_', $arCourse['NAME']) . ".chm\r\n"
			. "\r\n"
			. '[WINDOWS]' . "\r\n" 
			. 'bsm_wnd="1C-: ' . str_replace('"', "'", $arCourse['NAME']) 
			. '","bsm.hhc","bsm.hhk","index.htm","index.htm",,,,,0x63520,342,0x70184e,[24,27,1109,790],0xb0000,,,,,,0'
			. "\r\n\r\n"
			. "[FILES]\r\n";

		foreach ($arFilesToCopy as $fileName)
		{
			@copy(
				dirname(__FILE__) . '/' . $fileName,
				$this->destFolder . '/' . $fileName
			);
			$this->arFileList[] = $this->destFolder . '/' . $fileName;
			$this->dataHhp .= $fileName . "\r\n";
		}

		$fp = fopen($this->destFolder . '/index.htm', 'wb');

		if ($fp === false)
			throw new Exception();

		$this->arItems = $this->getTree();
		$this->itemsTotal = count($this->arItems);

		$content = $this->prepareContent($arCourse['NAME'], 
			$arCourse['DETAIL_TEXT'], 0, false);
		
		if (fwrite($fp, $content) === false)
			throw new Exception();

		if ( ! fclose($fp) )
			throw new Exception();

		$this->arFileList[] = $this->destFolder . '/index.htm';
	}


	public function finalize()
	{
		$this->dataHhk .= '</UL></BODY></HTML>';

		while (--$this->prevDepth)
			$this->dataHhc .= '</UL>';

		$this->dataHhc .= '</UL></BODY></HTML>';

		$this->flushData();

		fclose($this->fpHhp);
		fclose($this->fpHhk);
		fclose($this->fpHhc);
	}


	public function processItems()
	{
		$itemNum = 1;

		foreach ($this->arItems as $arItem)
			$this->processItem($arItem, $itemNum++);
	}


	public function processItem($arItem, $itemNum)
	{
		$link = $this->getNewLinkByLessonId($arItem['LESSON_ID']);

		$item = '<LI><OBJECT type="text/sitemap">
			<param name="Name" value="' . htmlentities($arItem['~NAME']) . '">
			<param name="Local" value="' . $link . '">
		</OBJECT>';

		if ($this->prevDepth !== false)
		{
			if ($arItem['DEPTH_LEVEL'] > $this->prevDepth)
				$this->dataHhc .= '<UL>';
			elseif ($arItem['DEPTH_LEVEL'] < $this->prevDepth)
				$this->dataHhc .= str_repeat('</UL>', $this->prevDepth - $arItem['DEPTH_LEVEL']);
		}

		$this->prevDepth = $arItem['DEPTH_LEVEL'];

		$this->dataHhc .= $item;
		$this->dataHhk .= $item;

		$content = $this->prepareContent($arItem['NAME'], $arItem['CONTENT'], $itemNum, $arItem['LESSON_ID']);

		$fileName = $this->destFolder . $link;
		$fp = fopen($fileName, 'wb');

		if ($fp === false)
			throw new Exception();
		
		if (fwrite($fp, $content) === false)
			throw new Exception();

		if ( ! fclose($fp) )
			throw new Exception();

		$this->arFileList[] = $fileName;

		if (mt_rand(1, 100) <= 5)
			$this->flushData();
	}


	protected function stripEmbed($lessonId, $content)
	{
		$href = str_replace(
			array('#COURSE_ID#', '#LESSON_ID#'),
			array($this->courseId, $lessonId),
			'http://dev.1c-bitrix.ru/learning/course/index.php?COURSE_ID=#COURSE_ID#&LESSON_ID=#LESSON_ID#'
		);

		$content = preg_replace(
			"/(<embed\s[^>]*>(.*)<\/embed>)/siU",
			'<span style="font-style:italic">       CHM .    <a target="_blank" href="' . $href . '">   &laquo;1-&raquo;</a>.</span>',
			$content
		);

		$content = preg_replace(
			"/(<iframe\s[^>]*>(.*)<\/iframe>)/siU",
			'<span style="font-style:italic">       CHM .    <a target="_blank" href="' . $href . '">   &laquo;1-&raquo;</a>.</span>',
			$content
		);

		$content = preg_replace(
			"/(<object\s[^>]*>(.*)<\/object>)/siU",
			'<span style="font-style:italic">       CHM .    <a target="_blank" href="' . $href . '">   &laquo;1-&raquo;</a>.</span>',
			$content
		);

		$content = preg_replace(
			"/(showFLVPlayer\((.*)\))/siU",
			'</script><span style="font-style:italic">       CHM .    <a target="_blank" href="' . $href . '">   &laquo;1-&raquo;</a>.</span><script>',
			$content
		);

		$content = preg_replace(
			"/(<p[^>]*><a href=\"javascript:ShowSwf\((.*)\(Flash\)<\/b><\/a><\/p>)/siU",
			'<span style="font-style:italic">       CHM .    <a target="_blank" href="' . $href . '">   &laquo;1-&raquo;</a>.</span>',
			$content
		);

		return ($content);
	}


	protected function prepareContent($name, $data, $itemNum, $lessonId)
	{
		$content = '
			<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
			<html>
			<head>
				<title>'.$name.'</title>
				<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
				<meta http-equiv="Content-Language" content="ru">

				<!--<sty le>@import url(do / cstyle.css);</style>-->
				<link href="docstyle.css" type="text/css" rel="stylesheet" />

				<script src="wow.js"></script>
			</head>

			<body id="dxBody" topMargin="0" onload="bodyLoad()" zzzonload="resizeBan()">
				<div id="pagetop" style="margin-bottom:5px;">
					<div id="page-title-box">
						<b class="r1"></b><b class="r0"></b>
						<div id="page-title-text">' . $name . '</div>
						<div id="page-title-numbers"><span title=" ">' . $itemNum 
							. '</span>&nbsp;/&nbsp;<span title=" ">' . $this->itemsTotal . '</span></div>
						<b class="r0"></b><b class="r1"></b>
					</div>
				</div>

				<div id="pagebody" valign="bottom">
				'
				. $this->replaceLinks($data, $lessonId)
				//. '<script>findFlash("/embed/41b7f3806e6e7692681378c01816d9b675a501f8.swf", 800, 600)</script>'
				. '<bitrix:sys name="feedbackform"></bitrix:sys>

					<table id="topicfooter" style="margin-top:25px;">
						<tr>
							<td> , 2001-2008, 1C-, 2008-'.date("Y").'</td>
							<td style="width: 50px">&nbsp;</td>
							<td style="text-align: right"><a href="http://www.1c-bitrix.ru" target="_blank">1-</a></td>
						</tr>
					</table>
				</div>
			</body>
			</html>
			';

		return ($content);
	}


	protected function getNewLinkByLessonId($lessonId)
	{
		return ('/lessons/LESSON_ID_' . $lessonId) . '.htm';
	}


	protected function replaceLinksCallback($in)
	{
		$origStr = $in[0];
		$rc      = $origStr;	// will be returned by default
		$url     = $in[1];

		$params  = self::convertUrlQuery(parse_url($url, PHP_URL_QUERY));
		$urlHash = parse_url($url, PHP_URL_FRAGMENT);

		if (isset($params['COURSE_ID']))
		{
			// Replace links within current course to internal links in CHM
			if (($params['COURSE_ID'] == $this->courseId) || ($params['COURSE_ID'] == '{SELF}'))
			{
				if (isset($params['CHAPTER_ID']))
				{
					if (substr($params['CHAPTER_ID'], 0, 1) === '0')
						$lessonId = (int) substr($params['CHAPTER_ID'], 1);
					else
						$lessonId = (int) CLearnLesson::LessonIdByChapterId ($params['CHAPTER_ID']);

					$newLink = $this->getNewLinkByLessonId($lessonId);

					if (strlen($urlHash))
						$newLink .= '#' . $urlHash;

					$rc = str_replace(
						$url,
						$newLink,
						$rc
					);
				}
				elseif (isset($params['LESSON_ID']))
				{
					$newLink = $this->getNewLinkByLessonId($params['LESSON_ID']);

					if (strlen($urlHash))
						$newLink .= '#' . $urlHash;

					$rc = str_replace(
						$url,
						$newLink,
						$rc
					);
				}

				$rc = str_replace(
					array(' target=blank', ' target=_blank', ' target="blank"', ' target="_blank"'),
					' ',
					$rc
				);
			}
			else
			{
				if (strpos($rc, ' href="/'))
					$rc = str_replace(' href="/', ' target="_blank" href="https://dev.1c-bitrix.ru/', $rc);
				else
					$rc = str_replace(' href="', ' target="_blank" href="', $rc);
			}
		}

		return ($rc);
	}


	protected static function convertUrlQuery($query)
	{
		$queryParts = explode('&', str_replace('&amp;', '&', $query));

		$params = array();
		foreach ($queryParts as $param)
		{
			$item = explode('=', $param);
			$params[$item[0]] = $item[1];
		}

		return $params;
	}



	protected function replaceLinks($content, $curLessonId)
	{
		$arReplaceWhat = array();
		$arReplaceBy   = array();

		// Process hrefs
		$content = preg_replace_callback(
			"/<a\s[^>]*href=\"([^\"]*)\"[^>]*>(.*)<\/a>/siU",
			array($this, 'replaceLinksCallback'),
			$content
		);

		// Process embed
		if ($curLessonId !== false)
			$content = $this->stripEmbed($curLessonId, $content);

		// Process images
		preg_match_all("/<img\s[^>]*src=\"([^\"]*)\"[^>]*>/siU", $content, $out);
		foreach($out[1] as $key => $imgLink)
		{
			$localImageName   = '/' . $this->saveFileLocally('images', $imgLink);
			$arReplaceWhat[]  = ' src="' . $imgLink . '"';

			// cut off leading double "//"
			if (substr($localImageName, 0, 2) === '//')
				$localImageName = substr($localImageName, 1);

			$arReplaceBy[] = ' src="' . $localImageName . '"';
		}

		$content = str_replace($arReplaceWhat, $arReplaceBy, $content);

		return ($content);
	}


	protected function saveFileLocally($folder, $fileLink)
	{
		$cacheKey = sha1($fileLink);

		if (isset($this->arProcessedFiles[$cacheKey]))
			return($this->arProcessedFiles[$cacheKey]);

		$ext = pathinfo($fileLink, PATHINFO_EXTENSION);
		$localName = $folder . '/' . sha1($fileLink) . '.' . $ext;
 
		$fullName = $this->destFolder . '/' . $localName;
		$fp = fopen($fullName, 'wb');

		if ($fp === false)
			throw new Exception();

		$sourcePath = $fileLink;
		if ( ! strpos($sourcePath, '://') )
			$sourcePath = str_replace('//', '/', $_SERVER['DOCUMENT_ROOT'] . '/' . $sourcePath);
		
		if (fwrite($fp, file_get_contents($sourcePath)) === false)
			throw new Exception();

		if ( ! fclose($fp) )
			throw new Exception();

		$this->arFileList[] = $fullName;

		$this->arProcessedFiles[$cacheKey] = '/' . $localName;
		$this->dataHhp .= $localName . "\r\n";

		return ($localName);
	}


	protected function flushData()
	{
		fwrite($this->fpHhp, $this->dataHhp);
		$this->dataHhp = '';

		fwrite($this->fpHhk, $this->dataHhk);
		$this->dataHhk = '';

		fwrite($this->fpHhc, $this->dataHhc);
		$this->dataHhc = '';
	}


	public function packToArchive($fileName)
	{
		static::makeArchive($this->arFileList, $this->destFolder, $fileName);
	}


	public static function makeArchive($arFileList, $sourceFolder, $destArchiveName)
	{
		$bUseCompression = false;

		if (extension_loaded('zlib') && function_exists('gzcompress'))
			$bUseCompression = true;

		$oArc = new CArchiver($destArchiveName, $bUseCompression);
		$oArc->SetOptions(array('STEP_TIME' => 1000));
		$res = $oArc->Add($arFileList, false, $sourceFolder);
	}


	public function getTree()
	{
		// Get Course Content
		$rsContent = CCourse::GetCourseContent(
			$this->courseId, 
			array(), 
			array('LESSON_ID', 'NAME')
		);

		$arContents = array();
		while ($arContent = $rsContent->GetNext())
		{
			$arData = CLearnLesson::GetByIDAsArr($arContent['LESSON_ID']);
			$arContent['CONTENT'] = $arData['DETAIL_TEXT'];
			$arContents[] = $arContent;
		}

		return ($arContents);
	}


	public function getFilesList()
	{
		return ($this->arFileList);
	}
}
